/// <reference types="node" />
import { BigNumber } from 'bignumber.js';
export interface TransactionParams {
    nonce: number;
    gasPriceWei: BigNumber;
    gasLimit: BigNumber;
    toAddress?: string | null;
    valueWei: BigNumber;
    data?: string | null;
    chainId?: number;
    v?: number;
    r?: string;
    s?: string;
}
export declare class Transaction {
    private nonce;
    private gasPriceWei;
    private gasLimit;
    private toAddress;
    private valueWei;
    private data;
    private chainId?;
    private v;
    private r;
    private s;
    constructor(params: TransactionParams);
    readonly fields: Buffer[];
    readonly rlp: Buffer;
    readonly hash: Buffer;
    readonly fieldsForSigning: Buffer[];
    readonly hashForSigning: Buffer;
    sign(privateKey: Buffer): Buffer;
}
